<?php


/**
 * @file Mysql.php
 * 
 * @author Matthieu DELOISON
 * @since 10 Juillet 2007
 * 
 * @version 0.1

 
@usage


$oSqlConnection = new Mysql();
$s_sqlSelect = "SELECT nbvisiteur FROM compteur_visite WHERE ip = '192.168.0.23'";
$o_sqlResult = $oSqlConnection->query($s_sqlSelect);
while ( $o_result = $oSqlConnection->getObject($o_sqlResult) )
{
	// caract�ristiques des messages
	$n_nbVisiteur = $o_result->nbvisiteur;
}

*/


/**
 * @note : dans l'avenir cette classe �tendra la classe PHP5 mysqli
 *
 */
class Mysql 
{
	
	private $oLinkSql;
	private $oResult;

	private $aConnect;
	 
	// ---------------------------------- __construct() ----------------------------------------------------------
   /**
	* @brief 
	* @param -
	*/
	public function __construct()
	{
		
		// initialisation des propri�t�s de la classe
		$this->aConnect 	= array();
		$port			= "3306";
		
		/* delfiweb */
		$this->aConnect['ip']	= "mysql4.8"; // le serveur
		$this->aConnect['login']	= "delfiweb"; // le login
		$this->aConnect['password']	= "zEwbvzSB"; // mot de passe
		$this->aConnect['database']	= "delfiweb"; // nom de la base de donnee
		$this->aConnect['port'] = "3306"; // 
		
		/* local
		$ip 			= "localhost";
		$login			= "root"; // le login
		$password		= ""; // mot de passe
		 */
		
		// adresse id  $_SERVER["REMOTE_ADDR"]; 
		
		if ( $this->oLinkSql = @mysqli_connect( $this->aConnect['ip'], $this->aConnect['login'], $this->aConnect['password'], $this->aConnect['database'], $this->aConnect['port'] ) )
		{
			$is_erreur = false ;
			$sql = 'SET CHARACTER SET \'utf8\''; 
			$this->query($sql); 
			$sql = 'SET collation_connection = \'utf8_general_ci\''; 
			$this->query($sql);
		}
		else // connexion error -> redirection to a webpage
		{
			echo "<meta http-equiv=\"refresh\" content=\"0; URL=erreurs/erreurBDD.htm\">";
			exit;
		}
		
	 }
	
	
	
	// -----------------------------------------------------------------------------------------------------------
	// ------------------------------------------- PUBLIC FUNCTIONS  ---------------------------------------------
	// -----------------------------------------------------------------------------------------------------------
	


	/**
	 * Return database config 
	 *
	 * @access public
	 * @param requete
	 * @return : an array with config of database
	 */
	public function getConfig()
	{
		return $this->aConnect;
	} 
	
	
	/**
	 * Execute a query 
	 *
	 * @access public
	 * @param requete
	 * @return : FALSE in error else an objet who contain the result.
	 */
	public  function query($sSqlQuery)
	{ 
		if ( $this->oResult = @mysqli_query($this->oLinkSql,$sSqlQuery) ) return $this->oResult;
		else return 'Query : '.$sSqlQuery.' - error : '.@mysqli_error($this->oLinkSql);
	}	
	 
	 
	 
	/*
	 * Give the result in an object.
	 *
	 * @access public
	 * @param $oResultQuery if we get the result of another query
	 */
	public function getObject($oResultQuery = NULL)
	{
		// give the result of another query
		if($oResultQuery!=NULL)
		{
			return @mysqli_fetch_object($oResultQuery);
			if ( @mysqli_error($this->oLinkSql) ) return @mysqli_error($this->oLinkSql);
		}
		
		// give the result of the current query
		if ($this->oResult != NULL)
		{
			return mysqli_fetch_object($this->oResult);
			if ( @mysqli_error($this->oLinkSql) ) return @mysqli_error($this->oLinkSql);
		}
		
	}

	
	
	// ---------------------------------- getNumRows() ----------------------------------------------------------
	/**
	* @brief give the number of affected rows by the last query.
	* @return (integer) number of affected rows.
	*/
	public function getNumRows()
	{
		if( $this->oLinkSql != NULL && $this->oLinkSql != false)
		{
			return @mysqli_affected_rows($this->oLinkSql);
				if (@mysqli_error($this->oLinkSql)) return @mysqli_error($this->oLinkSql);
		}
	}
	
	
	// ---------------------------------- lastInsertId() ----------------------------------------------------------
	/**
	* @brief give the last insert id. by the last query.
	* @return (integer) the last insert id.
	*/
	public function lastInsertId()
	{
		return @mysqli_insert_id($this->oLinkSql);
	}
	
	
	
	// -----------------------------------------------------------------------------------------------------------
	// ----------------------------------------- Others ----------------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------


 	/**
	* @brief
	*
	* @return 
	*/
	public function __destruct() 
	{
 		$this->oLinkSql = NULL ;		
		$b_rep = @mysqli_close($this->oLinkSql);
		if( $b_rep != true )
			return 'Erreur closing sql connexion!';
 	}
	
	
	
	// ---------------------------------------- __toString() ----------------------------------------------------	
	/**
	 * @brief Returns the string representation of this instance.
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  the string representation of this instance.
	 */	
	public function __toString() 
	{
		$s_classContent = "[Object ".__CLASS__."]<br />";

		foreach($this as $prop => $value) 
		{
		 	$s_classContent .= "$prop => $value <br />";
		}
		 
		return $s_classContent;
   	}
	 
}
?>